#include <QtGui/QApplication>
#include "mainwindow.h"
#include "osso-intl.h"
#include <QFile>
#include <QTextStream>

#include <libosso.h>
#define VERSION "0.1"
#define SERVICE_NAME "com.nokia.worldclock"

/*
//How to do this with QT?
//When starting another instance, instead raise this.
static gint rpc_callback(const gchar* interface, const gchar* method, GArray* arguments, gpointer user_data, osso_rpc_t* retval) {
	ClutterStage* stage;
	Display* display;
	Window window;
	XEvent event;

	stage = CLUTTER_STAGE(user_data);

	if (!strcmp(interface, SERVICE_NAME) && !strcmp(method, "top_application")) {
		display = clutter_x11_get_default_display();
		window = clutter_x11_get_stage_window(stage);

		XRaiseWindow(display, window);
		// Fremantle window manager does not obey XRaiseWindow, but reacts on _NET_ACTIVE_WINDOW messages.
		event.xclient.type = ClientMessage;
		event.xclient.message_type = XInternAtom(display, "_NET_ACTIVE_WINDOW", False);
		event.xclient.display = display;
		event.xclient.window = window;
		event.xclient.format = 32;
		event.xclient.data.l[0] = 1;
		event.xclient.data.l[1] = clutter_x11_get_current_event_time();
		event.xclient.data.l[2] = None;
		event.xclient.data.l[3] = 0;
		event.xclient.data.l[4] = 0;
		XSendEvent(display, clutter_x11_get_root_window(), False, SubstructureNotifyMask | SubstructureRedirectMask, &event);
	}

	retval->type = DBUS_TYPE_INVALID;

	return OSSO_OK;
}
*/

int main(int argc, char *argv[])
{
    intl("osso-clock");
    QApplication a(argc, argv);

    QString line, lang;
    QFile data( "/etc/osso-af-init/locale" );
    if (data.open(QFile::ReadOnly | QFile::Truncate))
    {
        QTextStream out(&data);
        while ( !out.atEnd() )
        {
            line = out.readLine();
            if ( line.indexOf("export LANG") == 0 )
            {
                lang = line;
                lang.replace("export LANG=","");
            }
        }
    }
    data.close();
    QLocale::setDefault(lang);

    MainWindow w;

    //Application must register it, unless system kills it.
    osso_context_t* osso_context;
    osso_context = osso_initialize(SERVICE_NAME, VERSION, 0, NULL);

    //Prevent starting more than one instance of application
    //g_assert(osso_rpc_set_default_cb_f(osso_context, rpc_callback, stage) == OSSO_OK); //pass MainWindow w instead of stage

#if defined(Q_WS_S60)
    w.showMaximized();
#else
    w.show();
#endif

    return a.exec();
}
